--freemarker template
<sqlvars>
<sqlvar name="mask_executions" type="hashsequence"><![CDATA[
select tid,userinfo_str , 
stylesheet_str , 
contenttype  , 
output_filename , 
name,
' -tid:' || maskeninfo_id || ' -out:tmp.xml -user:' || userinfo_str || ' -logger:$SUPERX_DIR/db/conf/logging.properties' as params1,
'-params:1=1' || trim(field_values) || '&stylesheet=' || stylesheet_str || '&contenttype=text/xml'  as params2
from tmp_execution
order by 1;]]>
</sqlvar>
<sqlvar name="mask_execution_asserts" type="hashsequence"><![CDATA[
SELECT tid,
       mask_execution_id,
       rownr,
       colnr,
       result_value_min,
       result_value_max,
       is_active
FROM qa_mask_execution_assert 
where mask_execution_id in (select tid from tmp_execution)
and is_active=1
order by 1;

 ]]>
</sqlvar>
</sqlvars>

<#assign shebang="!" />
<#if SQLdialect='Postgres'>
<#assign shebang="\\!" />

drop table if exists tmp_result_upload;
drop table if exists tmp_result;

</#if>
<#assign type_timestamp="datetime year to second" />
<#if SQLdialect='Postgres'>
<#assign type_timestamp="timestamptz" />
</#if>
<#foreach mask_execution in mask_executions>
select 'Start Ausführung: ${mask_execution.tid} ${mask_execution.name}' from xdummy;

create table tmp_result_upload(
execution_start ${type_timestamp} , 
execution_end ${type_timestamp} , 
result_log TEXT,
result_code SMALLINT 
);

create table tmp_result(
mask_execution_assert_id integer,
mask_execution_result_id integer,
execution_start ${type_timestamp} , 
execution_end ${type_timestamp} , 
result_log TEXT,
result_code SMALLINT 
);



${shebang} ./execute_mask.x ${mask_execution.params1} "${mask_execution.params2}"

${shebang} SX_CLIENT=jdbc; sx_auto_upload_table.x tmp_result_upload $WEBAPP/WEB-INF/mask_execution_log.xml false xml

insert into tmp_result(execution_start , execution_end, result_log, result_code)
select execution_start , execution_end, result_log, result_code from tmp_result_upload;

insert into qa_mask_execution_result(
mask_execution_id)
values (${mask_execution.tid});

update tmp_result set mask_execution_result_id=(select max(tid) from qa_mask_execution_result);

<#if SQLdialect='Postgres'>
--Postgres Dialekt:
update qa_mask_execution_result set 
execution_start =T. execution_start, 
execution_end =T.execution_end , 
result_log=T.result_log,
result_code=T.result_code
from tmp_result T
where T.mask_execution_result_id=qa_mask_execution_result.tid;
<#else>
--Informix Dialekt:
update qa_mask_execution_result set (execution_start,
       execution_end,
       result_code) 
       = ((select 
       T.execution_start,
       T.execution_end,
       T.result_code
from tmp_result T
where  T.mask_execution_result_id=qa_mask_execution_result.tid
))
where qa_mask_execution_result.tid =(select T.mask_execution_result_id
from tmp_result T)
;

--BLOB Spalte muss separat geupdated werden:
update qa_mask_execution_result set result_log=(select 
       T.result_log
from tmp_result T
where  T.mask_execution_result_id=qa_mask_execution_result.tid
)
where qa_mask_execution_result.tid = (select T.mask_execution_result_id
from tmp_result T)
;
</#if>


<#foreach mask_execution_assert in mask_execution_asserts>
<#if mask_execution_assert.mask_execution_id==mask_execution.tid>

select 'Start Assertion: ${mask_execution_assert.tid}' from xdummy;

${shebang} echo "Start sx_transform.x -IN:$WEBAPP/WEB-INF/tmp.xml -XSL:mask_assertion.xsl -OUT:tmp_mask_assertion_result.sql -method:text -params:mask_execution_id=${mask_execution_assert.mask_execution_id},mask_execution_assert_id=${mask_execution_assert.tid},rownr=${mask_execution_assert.rownr},colnr=${mask_execution_assert.colnr}"
${shebang} sx_transform.x -IN:$WEBAPP/WEB-INF/tmp.xml -XSL:mask_assertion.xsl -OUT:tmp_mask_assertion_result.sql -method:text -params:mask_execution_id=${mask_execution_assert.mask_execution_id},mask_execution_assert_id=${mask_execution_assert.tid},rownr=${mask_execution_assert.rownr},colnr=${mask_execution_assert.colnr}
${shebang} DOSQL  tmp_mask_assertion_result.sql
</#if>
</#foreach>

drop table tmp_result_upload;
drop table tmp_result;
</#foreach>

drop table tmp_execution;
