
--freemarker template

<#assign systeminfo_id=9 />
<#assign sachgebiete_id=0 />


<#assign projects= [
{"uniquename":"kern_user",
"name":"Kernmodul Benutzerverwaltung",
"issue_link":"https://git.campussource.de/git/SuperX/qa/issues/"
}
  ] />

<#assign resultsets = [
{"uniquename":"userinfo",
"name":"Benutzeraccounts",
"fieldclause":"U.*",
"fromclause":"userinfo U",
"groupbyclause":"",
"orderbyclause":""
}
  ] />

<#assign  dbtests = [
    {
  "project":"kern_user",
  "uniquename":"kern_adminuser_exists",
  "name":"Benutzeraccount mit Administrationsrechten existiert", 
  "resultset":"userinfo",
  "whereclause":"benutzer=''admin''",
  "description":"",
  "issue_id":"1"
  }
    
 ] />
 
 <#assign  dbtest_assertions = [
  
   {
  "dbtest":"kern_adminuser_exists",
  "rownr":"1",
   "assertion_col": "benutzer",
  "assertion_value": "adim",
 "assertion_caption":"Admin-Account"
  }  
 ] />


--ab hier ist der Code immer gleich:
<#foreach resultset in resultsets>
insert into qa_resultset(
  uniquename,
       name,
       systeminfo_id,
       fromclause,
       fieldclause,
       groupbyclause,
       orderbyclause)
select 
'${resultset.uniquename}',
'${resultset.name}',
${systeminfo_id},
'${resultset.fromclause}',
'${resultset.fieldclause}',
'${resultset.groupbyclause}',
'${resultset.orderbyclause}'
from xdummy
where 0=(select count(*) from qa_resultset R
where R.uniquename='${resultset.uniquename}'
and R.systeminfo_id=${systeminfo_id})
;
</#foreach>


<#foreach project in projects>

insert into qa_project(
uniquename,
       name,
       systeminfo_id,
       sachgebiete_id,
       active,
       issue_link,
       created_at,
       created_from
)
select 
'${project.uniquename}',
'${project.name}',
${systeminfo_id},
${sachgebiete_id},
1 as active,
'${project.issue_link}',
today(),
1
from xdummy
where 0=(select count(*) from qa_project P
where P.uniquename='${project.uniquename}'
and P.systeminfo_id=${systeminfo_id});

<#foreach dbtest in dbtests>
<#if dbtest.project=project.uniquename>
insert into qa_dbtest(
uniquename,
name,
systeminfo_id,
resultset_id,
whereclause,
description,
active)
 select '${dbtest.uniquename}',
'${dbtest.name}',
${systeminfo_id},
(select R.tid from qa_resultset R where R.uniquename='${dbtest.resultset}'
and R.systeminfo_id=${systeminfo_id}
) as resultset_id,
'${dbtest.whereclause}',
'${dbtest.description}',
1 as active
FROM qa_project
where uniquename= '${project.uniquename}'
and systeminfo_id=${systeminfo_id}
and 0=(select count(*) from qa_dbtest T
where T.uniquename='${dbtest.uniquename}'
and T.systeminfo_id=${systeminfo_id})
;

insert into qa_dbtest2project(  dbtest_id,
project_id,
issue_id)
       select T.tid,
       P.tid,
'${dbtest.issue_id}'
       FROM qa_dbtest T,qa_project P
       where T.uniquename='${dbtest.uniquename}'
       and T.systeminfo_id=${systeminfo_id}
       and P.uniquename= '${project.uniquename}'
       and P.systeminfo_id=${systeminfo_id}
       and 0=(select count(*) from qa_dbtest2project TP,
       qa_dbtest T,qa_project P
where T.uniquename='${dbtest.uniquename}'
and T.systeminfo_id=${systeminfo_id} 
 and P.uniquename= '${project.uniquename}'
       and P.systeminfo_id=${systeminfo_id}
       and TP.project_id=P.tid
       and TP.dbtest_id=T.tid)
       ;
<#foreach assertion in dbtest_assertions>
<#if assertion.dbtest=dbtest.uniquename>
insert into qa_dbtest_assertion(
dbtest_id,
       rownr,
       def_col_caption,
       def_col_name,
       def_col_value
       )
select tid,
${assertion.rownr},
'${assertion.assertion_caption}',
'${assertion.assertion_col}',
'${assertion.assertion_value}'
from qa_dbtest T
where T.uniquename='${dbtest.uniquename}'
and T.systeminfo_id=${systeminfo_id}
and 0=(select count(*) from qa_dbtest_assertion A
where A.dbtest_id=T.tid
and A.rownr=${assertion.rownr}
and A.def_col_name='${assertion.assertion_col}'
);
 

</#if> --von assertion
</#foreach>



</#if> --von dbtest
</#foreach>
</#foreach>

